import { Control } from "@react-typed-forms/core";
import { SelectProps, TextFieldProps } from "@mui/material";
import React, { ReactNode } from "react";
type stringOrNumber = string | number;
export interface SelectOption {
    value: stringOrNumber;
    name: string;
}
type FSelectValue = stringOrNumber;
export type FSelectProps = {
    state: Control<FSelectValue | undefined | null>;
    options: SelectOption[];
    renderItem?: (name: string, selected: boolean) => ReactNode;
    emptyText?: string;
} & Omit<TextFieldProps, "onChange" | "children" | "select">;
export declare function FSelect({ state, helperText, options, defaultValue, renderItem, emptyText, ...props }: FSelectProps): React.JSX.Element;
export type FSelectOnlyProps = {
    state: Control<FSelectValue | undefined | null>;
    options: SelectOption[];
    renderItem?: (name: string, selected: boolean) => ReactNode;
} & Omit<SelectProps, "onChange" | "children" | "select">;
export declare function FSelectOnly({ state, options, defaultValue, renderItem, ...props }: FSelectOnlyProps): React.JSX.Element;
export {};
