var core = require('@react-typed-forms/core');
var material = require('@mui/material');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function (n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _objectWithoutPropertiesLoose(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (e.includes(n)) continue;
    t[n] = r[n];
  }
  return t;
}

var _excluded$8 = ["state", "label", "getOptionLabel"];
function FAutocomplete(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      label = _ref.label,
      getOptionLabel = _ref.getOptionLabel,
      others = _objectWithoutPropertiesLoose(_ref, _excluded$8);
    return /*#__PURE__*/React__default["default"].createElement(core.RenderControl, {
      children: function children() {
        var error = state.error;
        var value = state.value;
        return /*#__PURE__*/React__default["default"].createElement(material.Autocomplete, _extends({}, others, {
          freeSolo: true,
          onChange: function onChange(event, newValue, reason) {
            if (reason === "selectOption") {
              var _getOptionLabel;
              var newTextValue = typeof newValue === "string" ? newValue : (_getOptionLabel = getOptionLabel == null ? void 0 : getOptionLabel(newValue)) != null ? _getOptionLabel : newValue.toString();
              state.value = newTextValue;
            }
          },
          inputValue: value || "",
          onInputChange: function onInputChange(_, val, reason) {
            if (reason === "input" || reason === "clear") {
              state.value = val;
            }
          },
          getOptionLabel: getOptionLabel,
          renderInput: function renderInput(p) {
            return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({}, p, {
              label: label,
              ref: function ref(e) {
                return state.element = e;
              },
              error: Boolean(error),
              helperText: error,
              variant: "outlined"
            }));
          }
        }));
      }
    });
  } finally {
    _effect();
  }
}

var _excluded$7 = ["state"];
var FCheckbox = function FCheckbox(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$7);
    var _formControlProps = core.formControlProps(state),
      ref = _formControlProps.ref,
      value = _formControlProps.value,
      disabled = _formControlProps.disabled;
    return /*#__PURE__*/React__default["default"].createElement(material.FormControlLabel, _extends({
      control: /*#__PURE__*/React__default["default"].createElement(material.Checkbox, {
        ref: ref,
        checked: Boolean(value),
        disabled: disabled,
        onChange: function onChange(_, v) {
          state.value = v;
          state.touched = true;
        }
      })
    }, props));
  } finally {
    _effect();
  }
};

function FCheckboxOnly(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state;
    var _formControlProps = core.formControlProps(state),
      value = _formControlProps.value,
      disabled = _formControlProps.disabled;
    return /*#__PURE__*/React__default["default"].createElement(material.Checkbox, {
      onChange: function onChange(_, v) {
        return state.value = v;
      },
      checked: Boolean(value),
      disabled: disabled,
      color: "primary"
    });
  } finally {
    _effect();
  }
}

function FCheckList(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var isSelected = function isSelected(v) {
      return state.current.value.find(function (a) {
        return comp(a, v);
      }) != null;
    };
    var state = _ref.state,
      _children = _ref.children,
      label = _ref.label,
      helperText = _ref.helperText,
      compare = _ref.compare;
    var comp = compare != null ? compare : function (a, b) {
      return a === b;
    };
    var checkProps = function checkProps(v) {
      return {
        checked: isSelected(v),
        disabled: state.disabled,
        onChange: function onChange(e, c) {
          var current = isSelected(v);
          if (current !== c) {
            state.setValue(function (x) {
              return current ? x.filter(function (a) {
                return !comp(a, v);
              }) : [].concat(x, [v]);
            });
          }
        }
      };
    };
    return /*#__PURE__*/React__default["default"].createElement(core.RenderForm, {
      control: state,
      children: function children(_ref2) {
        var errorText = _ref2.errorText;
        return /*#__PURE__*/React__default["default"].createElement(material.FormControl, {
          error: Boolean(errorText)
        }, /*#__PURE__*/React__default["default"].createElement(material.FormLabel, null, label), _children(checkProps), /*#__PURE__*/React__default["default"].createElement(material.FormHelperText, null, errorText != null ? errorText : helperText));
      }
    });
  } finally {
    _effect();
  }
}

var _excluded$6 = ["state", "helperText"],
  _excluded2$4 = ["errorText", "value"];
var FDateField = function FDateField(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      helperText = _ref.helperText,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$6);
    return /*#__PURE__*/React__default["default"].createElement(core.RenderForm, {
      control: state,
      children: function children(_ref2) {
        var errorText = _ref2.errorText,
          value = _ref2.value,
          formProps = _objectWithoutPropertiesLoose(_ref2, _excluded2$4);
        return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({}, formProps, {
          value: !value ? "" : value,
          error: Boolean(errorText)
        }, props, {
          type: "date",
          helperText: errorText != null ? errorText : helperText,
          InputLabelProps: {
            shrink: true
          }
        }));
      }
    });
  } finally {
    _effect();
  }
};

function FFormControl(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var label = _ref.label,
      state = _ref.state,
      helperText = _ref.helperText,
      control = _ref.control;
    var uniqueId = state.uniqueId;
    var error = state.touched && !state.valid ? state.error : undefined;
    var id = "input_" + uniqueId;
    var textId = "helptext_" + uniqueId;
    return /*#__PURE__*/React__default["default"].createElement(material.FormControl, null, /*#__PURE__*/React__default["default"].createElement(material.InputLabel, {
      htmlFor: id
    }, label), control({
      id: id,
      ariaDescribedBy: textId
    }), /*#__PURE__*/React__default["default"].createElement(material.FormHelperText, {
      id: "textId",
      error: Boolean(error)
    }, error || helperText));
  } finally {
    _effect();
  }
}

var _excluded$5 = ["state", "helperText", "options", "defaultValue", "renderItem"],
  _excluded2$3 = ["ref", "errorText", "value"];
function FMultiSelect(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      helperText = _ref.helperText,
      options = _ref.options,
      defaultValue = _ref.defaultValue,
      renderItem = _ref.renderItem,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$5);
    return /*#__PURE__*/React__default["default"].createElement(core.RenderForm, {
      control: state,
      children: function children(_ref2) {
        var ref = _ref2.ref,
          errorText = _ref2.errorText,
          value = _ref2.value,
          formProps = _objectWithoutPropertiesLoose(_ref2, _excluded2$3);
        return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({
          inputRef: ref
        }, formProps, props, {
          value: typeof value === "undefined" ? [] : value,
          select: true,
          error: Boolean(errorText),
          helperText: errorText != null ? errorText : helperText,
          SelectProps: {
            displayEmpty: true,
            multiple: true,
            renderValue: function renderValue(values) {
              if (values === "") {
                return "";
              }
              var allValues = values;
              return allValues.map(function (v) {
                var _options$find$name, _options$find;
                return (_options$find$name = (_options$find = options.find(function (x) {
                  return x.value === v;
                })) == null ? void 0 : _options$find.name) != null ? _options$find$name : "<unknown : " + v + ">";
              }).join(", ");
            }
          },
          InputLabelProps: {
            shrink: true
          }
        }), options.map(function (option) {
          var _renderItem;
          return /*#__PURE__*/React__default["default"].createElement(material.MenuItem, {
            key: option.value,
            value: option.value
          }, (_renderItem = renderItem == null ? void 0 : renderItem(option.name, (value != null ? value : []).includes(option.value))) != null ? _renderItem : option.name);
        }));
      }
    });
  } finally {
    _effect();
  }
}

var _excluded$4 = ["state", "onChange", "helperText"],
  _excluded2$2 = ["errorText", "value"];
function FNumberField(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var makeTextAndValue = function makeTextAndValue(value) {
      return [typeof value === "number" ? value : "", value];
    };
    var state = _ref.state,
      onChange = _ref.onChange,
      helperText = _ref.helperText,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$4);
    var _useState = React.useState(makeTextAndValue(state.current.value)),
      field = _useState[0],
      setField = _useState[1];
    core.useControlEffect(function () {
      return state.value;
    }, function (v) {
      return setField(function (fv) {
        return fv[1] === v ? fv : makeTextAndValue(v);
      });
    });
    return /*#__PURE__*/React__default["default"].createElement(core.RenderForm, {
      control: state,
      children: function children(_ref2) {
        var errorText = _ref2.errorText,
          value = _ref2.value,
          formProps = _objectWithoutPropertiesLoose(_ref2, _excluded2$2);
        return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({}, formProps, {
          value: field[0],
          onChange: function onChange(e) {
            var textValue = e.target.value;
            var v = parseFloat(textValue);
            var newValue = isNaN(v) ? undefined : v;
            setField([textValue, v]);
            state.value = newValue;
          },
          type: "number",
          error: Boolean(errorText)
        }, props, {
          helperText: errorText != null ? errorText : helperText
        }));
      }
    });
  } finally {
    _effect();
  }
}

var _excluded$3 = ["state", "value", "defaultValue"];
function FRadioButton(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      value = _ref.value,
      defaultValue = _ref.defaultValue,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$3);
    return /*#__PURE__*/React__default["default"].createElement(core.RenderForm, {
      control: state,
      children: function children(_ref2) {
        var ref = _ref2.ref,
          fValue = _ref2.value,
          disabled = _ref2.disabled;
        return /*#__PURE__*/React__default["default"].createElement(material.FormControlLabel, _extends({
          control: /*#__PURE__*/React__default["default"].createElement(material.Radio, {
            ref: ref,
            name: "_r" + state.uniqueId,
            checked: fValue === value,
            disabled: disabled,
            onChange: function onChange(_, v) {
              state.value = v ? value : defaultValue;
              state.touched = true;
            }
          })
        }, props));
      }
    });
  } finally {
    _effect();
  }
}

function FRadioList(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      children = _ref.children,
      label = _ref.label,
      helperText = _ref.helperText;
    var checkProps = function checkProps(v) {
      return {
        checked: v === state.value,
        onChange: function onChange(e, c) {
          state.value = v;
        }
      };
    };
    var _formControlProps = core.formControlProps(state),
      errorText = _formControlProps.errorText;
    return /*#__PURE__*/React__default["default"].createElement(material.FormControl, {
      error: Boolean(errorText)
    }, /*#__PURE__*/React__default["default"].createElement(material.FormLabel, null, label), children(checkProps), /*#__PURE__*/React__default["default"].createElement(material.FormHelperText, null, errorText != null ? errorText : helperText));
  } finally {
    _effect();
  }
}

var _excluded$2 = ["state", "helperText", "options", "defaultValue", "renderItem", "emptyText"],
  _excluded2$1 = ["ref", "errorText", "value"],
  _excluded3 = ["state", "options", "defaultValue", "renderItem"],
  _excluded4 = ["ref", "value", "onChange"];
function FSelect(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      helperText = _ref.helperText,
      options = _ref.options,
      defaultValue = _ref.defaultValue,
      renderItem = _ref.renderItem,
      emptyText = _ref.emptyText,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$2);
    var _formControlProps = core.formControlProps(state),
      ref = _formControlProps.ref,
      errorText = _formControlProps.errorText,
      value = _formControlProps.value,
      formProps = _objectWithoutPropertiesLoose(_formControlProps, _excluded2$1);
    return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({
      inputRef: ref
    }, formProps, props, {
      value: value == null ? "" : value,
      select: true,
      error: Boolean(errorText),
      helperText: errorText != null ? errorText : helperText,
      SelectProps: {
        displayEmpty: true,
        renderValue: function renderValue(values) {
          var _options$find$name, _options$find;
          var stringValue = values;
          if (typeof stringValue != null) return (_options$find$name = (_options$find = options.find(function (x) {
            return x.value === stringValue;
          })) == null ? void 0 : _options$find.name) != null ? _options$find$name : !stringValue ? emptyText : "<unknown : " + stringValue + ">";else return "";
        }
      },
      InputLabelProps: {
        shrink: true
      }
    }), options.map(function (option) {
      var _renderItem;
      return /*#__PURE__*/React__default["default"].createElement(material.MenuItem, {
        key: option.value,
        value: option.value
      }, (_renderItem = renderItem == null ? void 0 : renderItem(option.name, option.value == value)) != null ? _renderItem : option.name);
    }));
  } finally {
    _effect();
  }
}
function FSelectOnly(_ref2) {
  var _effect2 = core.useComponentTracking();
  try {
    var state = _ref2.state,
      options = _ref2.options,
      defaultValue = _ref2.defaultValue,
      renderItem = _ref2.renderItem,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded3);
    var _formControlProps2 = core.formControlProps(state),
      ref = _formControlProps2.ref,
      value = _formControlProps2.value,
      onChange = _formControlProps2.onChange,
      formProps = _objectWithoutPropertiesLoose(_formControlProps2, _excluded4);
    return /*#__PURE__*/React__default["default"].createElement(material.Select, _extends({
      inputRef: ref
    }, formProps, props, {
      onChange: function onChange(e, v) {
        return console.log({
          e: e,
          v: v
        });
      },
      value: value == null ? "" : value,
      displayEmpty: true,
      renderValue: function renderValue(values) {
        var _options$find$name2, _options$find2;
        var stringValue = values;
        if (typeof stringValue === "string") return (_options$find$name2 = (_options$find2 = options.find(function (x) {
          return x.value === stringValue;
        })) == null ? void 0 : _options$find2.name) != null ? _options$find$name2 : "<unknown : " + stringValue + ">";else return "";
      }
    }), options.map(function (option) {
      var _renderItem2;
      return /*#__PURE__*/React__default["default"].createElement(material.MenuItem, {
        key: option.value,
        value: option.value
      }, (_renderItem2 = renderItem == null ? void 0 : renderItem(option.name, option.value == value)) != null ? _renderItem2 : option.name);
    }));
  } finally {
    _effect2();
  }
}

var _excluded$1 = ["state", "query", "label", "getOptionLabel"];
function FSelectAutocomplete(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      query = _ref.query,
      label = _ref.label,
      getOptionLabel = _ref.getOptionLabel,
      others = _objectWithoutPropertiesLoose(_ref, _excluded$1);
    return /*#__PURE__*/React__default["default"].createElement(core.RenderControl, {
      children: function children() {
        var error = state.error;
        var queryValue = query.value;
        return /*#__PURE__*/React__default["default"].createElement(material.Autocomplete, _extends({}, others, {
          onChange: function onChange(event, newValue, reason) {
            if (reason === "selectOption") {
              state.value = newValue;
              query.setValue(function () {
                var _getOptionLabel;
                return (_getOptionLabel = getOptionLabel == null ? void 0 : getOptionLabel(newValue)) != null ? _getOptionLabel : newValue.toString();
              });
            }
          },
          inputValue: queryValue || "",
          onInputChange: function onInputChange(_, val, reason) {
            if (reason === "input" || reason === "clear") {
              query.value = val;
            }
          },
          getOptionLabel: getOptionLabel,
          renderInput: function renderInput(p) {
            return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({}, p, {
              label: label,
              ref: function ref(e) {
                return state.element = e;
              },
              error: Boolean(error),
              helperText: error,
              variant: "outlined"
            }));
          }
        }));
      }
    });
  } finally {
    _effect();
  }
}

function FSelectionList(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var handleToggleAll = function handleToggleAll(items) {
      core.groupedChanges(function () {
        return items.forEach(function (x) {
          return x.fields.selected.setValue(function (x) {
            return !x;
          });
        });
      });
    };
    var control = _ref.control,
      entryName = _ref.entryName,
      title = _ref.title,
      entrySelected = _ref.entrySelected,
      style = _ref.style,
      elevation = _ref.elevation;
    return /*#__PURE__*/React__default["default"].createElement(core.RenderElements, {
      control: control,
      container: function container(children, items) {
        var numChecked = items.map(function (x) {
          return x.fields.selected.value;
        }).reduce(function (c, n) {
          return n ? c + 1 : c;
        }, 0);
        var numTables = items.length;
        return /*#__PURE__*/React__default["default"].createElement(material.Card, {
          style: style,
          elevation: elevation,
          sx: {
            m: 1
          }
        }, /*#__PURE__*/React__default["default"].createElement(material.CardHeader, {
          sx: {
            px: 2,
            py: 1
          },
          avatar: /*#__PURE__*/React__default["default"].createElement(material.Checkbox, {
            onClick: function onClick() {
              return handleToggleAll(items);
            },
            checked: numChecked === numTables && numTables !== 0,
            indeterminate: numChecked !== numTables && numChecked !== 0,
            disabled: numTables === 0 || control.disabled,
            inputProps: {
              "aria-label": "all items selected"
            }
          }),
          title: title,
          subheader: numChecked + "/" + items.length + " selected"
        }), /*#__PURE__*/React__default["default"].createElement(material.Divider, null), /*#__PURE__*/React__default["default"].createElement(material.List, {
          sx: {
            bgcolor: "background.paper"
          },
          dense: true,
          component: "div",
          role: "list"
        }, children, /*#__PURE__*/React__default["default"].createElement(material.ListItem, null)));
      }
    }, function (i) {
      return /*#__PURE__*/React__default["default"].createElement(SelectionEntry, {
        key: i.uniqueId,
        disabled: control.disabled,
        control: i,
        entryName: entryName,
        entrySelected: entrySelected
      });
    });
  } finally {
    _effect();
  }
}
function SelectionEntry(_ref2) {
  var _effect2 = core.useComponentTracking();
  try {
    var control = _ref2.control,
      entryName = _ref2.entryName,
      entrySelected = _ref2.entrySelected,
      disabled = _ref2.disabled;
    var _control$fields = control.fields,
      selected = _control$fields.selected,
      value = _control$fields.value;
    var isSelected = selected.value;
    var isEntrySelected = core.useComputed(function () {
      return (entrySelected == null ? void 0 : entrySelected.value) === control;
    }).value;
    var name = entryName(value.value);
    return /*#__PURE__*/React__default["default"].createElement(material.ListItemButton, {
      role: "listitem",
      onClick: entrySelected ? function () {
        return entrySelected.value = control;
      } : undefined,
      selected: isEntrySelected
    }, /*#__PURE__*/React__default["default"].createElement(material.ListItemIcon, null, /*#__PURE__*/React__default["default"].createElement(material.Checkbox, {
      checked: isSelected,
      tabIndex: -1,
      disableRipple: true,
      disabled: disabled,
      onClick: function onClick() {
        return selected.setValue(function (x) {
          return !x;
        });
      }
    })), /*#__PURE__*/React__default["default"].createElement(material.ListItemText, {
      primary: name
    }));
  } finally {
    _effect2();
  }
}

var _excluded = ["state", "helperText"],
  _excluded2 = ["errorText", "value"];
function FTextField(_ref) {
  var _effect = core.useComponentTracking();
  try {
    var state = _ref.state,
      helperText = _ref.helperText,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);
    var _formControlProps = core.formControlProps(state),
      errorText = _formControlProps.errorText,
      value = _formControlProps.value,
      formProps = _objectWithoutPropertiesLoose(_formControlProps, _excluded2);
    return /*#__PURE__*/React__default["default"].createElement(material.TextField, _extends({}, formProps, {
      value: !value ? "" : value,
      error: Boolean(errorText)
    }, props, {
      helperText: errorText != null ? errorText : helperText
    }));
  } finally {
    _effect();
  }
}

exports.FAutocomplete = FAutocomplete;
exports.FCheckList = FCheckList;
exports.FCheckbox = FCheckbox;
exports.FCheckboxOnly = FCheckboxOnly;
exports.FDateField = FDateField;
exports.FFormControl = FFormControl;
exports.FMultiSelect = FMultiSelect;
exports.FNumberField = FNumberField;
exports.FRadioButton = FRadioButton;
exports.FRadioList = FRadioList;
exports.FSelect = FSelect;
exports.FSelectAutocomplete = FSelectAutocomplete;
exports.FSelectOnly = FSelectOnly;
exports.FSelectionList = FSelectionList;
exports.FTextField = FTextField;
//# sourceMappingURL=index.js.map
